CREATE DATABASE RTAppSec
GO

USE RTAppSec
GO

ALTER DATABASE RTAppSec
SET RECOVERY FULL
GO

CREATE TABLE USERS
(
	user_id		INT NOT NULL IDENTITY PRIMARY KEY,
	user_name	VARCHAR(255) NOT NULL,
	user_status	VARCHAR(255) NOT NULL
)
GO

CREATE TABLE ALLOWED_APPS
(
	app_id		INT NOT NULL,
	user_id		INT NOT NULL
)
GO

CREATE TABLE APPS
(
	app_id		INT NOT NULL IDENTITY PRIMARY KEY,
	app_name	VARCHAR(255) NOT NULL
)
GO

CREATE TABLE APP_EXES
(
	exe_id		INT NOT NULL IDENTITY PRIMARY KEY,
	exe_path	VARCHAR(255) NOT NULL,
	app_id		INT NULL
)
GO

CREATE TABLE ACCESS_REQUESTS
(
	request_id	INT NOT NULL IDENTITY PRIMARY KEY,
	user_id		INT NOT NULL,
	exe_id		INT NOT NULL
)
GO

EXEC sp_grantlogin 'BUILTIN\Power Users'
GO

EXEC sp_grantlogin 'BUILTIN\Users'
GO

EXEC sp_grantlogin 'BUILTIN\Guests'
GO

EXEC sp_grantdbaccess 'BUILTIN\Power Users', 'Power Users'
GO

EXEC sp_grantdbaccess 'BUILTIN\Users', 'Users'
GO

EXEC sp_grantdbaccess 'BUILTIN\Guests', 'Guests'
GO

EXEC sp_addrole 'RTAppSec'
GO

GRANT SELECT, INSERT ON USERS TO RTAppSec
GRANT SELECT, INSERT ON ALLOWED_APPS TO RTAppSec
GRANT SELECT, INSERT ON APPS TO RTAppSec
GRANT SELECT, INSERT ON APP_EXES TO RTAppSec
GRANT SELECT, INSERT ON ACCESS_REQUESTS TO RTAppSec
GO

EXEC sp_addrolemember 'RTAppSec', 'Power Users'
GO

EXEC sp_addrolemember 'RTAppSec', 'Users'
GO

EXEC sp_addrolemember 'RTAppSec', 'Guests'
GO
